---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for FMC ADC 18bits 400kS/s core registers
---------------------------------------------------------------------------------------
-- File           : fmc_adc_18b_400ks_csr.vhd
-- Author         : auto-generated by wbgen2 from ./fmc_adc_18b_400ks_csr.wb
-- Created        : Tue Aug  4 16:21:58 2015
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE ./fmc_adc_18b_400ks_csr.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity fmc_adc_18b_400ks_csr is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    wb_adr_i                                 : in     std_logic_vector(3 downto 0);
    wb_dat_i                                 : in     std_logic_vector(31 downto 0);
    wb_dat_o                                 : out    std_logic_vector(31 downto 0);
    wb_cyc_i                                 : in     std_logic;
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
    wb_stb_i                                 : in     std_logic;
    wb_we_i                                  : in     std_logic;
    wb_ack_o                                 : out    std_logic;
    wb_stall_o                               : out    std_logic;
    adc_clk_i                                : in     std_logic;
-- Port for std_logic_vector field: 'State machine commands (ignore on read)' in reg: 'Control register'
    fmc_adc_core_ctl_fsm_cmd_o               : out    std_logic_vector(1 downto 0);
-- Port for BIT field: 'Range' in reg: 'Control register'
    fmc_adc_core_ctl_adc_volt_rage_o         : out    std_logic;
-- Port for std_logic_vector field: 'Oversampling Mode' in reg: 'Control register'
    fmc_adc_core_ctl_adc_os_o                : out    std_logic_vector(2 downto 0);
-- Port for asynchronous (clock: adc_clk_i) BIT field: 'not Double Rate Input' in reg: 'Control register'
    fmc_adc_core_ctl_adc_n_dbl_rate_o        : out    std_logic;
-- Port for std_logic_vector field: 'Reserved' in reg: 'Control register'
    fmc_adc_core_ctl_reserved_i              : in     std_logic_vector(24 downto 0);
-- Port for std_logic_vector field: 'State machine status' in reg: 'Status register'
    fmc_adc_core_sta_fsm_i                   : in     std_logic_vector(2 downto 0);
-- Port for asynchronous (clock: adc_clk_i) std_logic_vector field: 'ADC State machine status' in reg: 'Status register'
    fmc_adc_core_sta_adc_fsm_i               : in     std_logic_vector(2 downto 0);
-- Port for std_logic_vector field: 'Reserved' in reg: 'Status register'
    fmc_adc_core_sta_reserved_i              : in     std_logic_vector(25 downto 0);
-- Port for std_logic_vector field: 'ADC Chanel1' in reg: 'ADC Chanel 1'
    fmc_adc_core_adc_ch1_i                   : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'ADC Chanel2' in reg: 'ADC Chanel 2'
    fmc_adc_core_adc_ch2_i                   : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'ADC Chanel3' in reg: 'ADC Chanel 3'
    fmc_adc_core_adc_ch3_i                   : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'ADC Chanel4' in reg: 'ADC Chanel 4'
    fmc_adc_core_adc_ch4_i                   : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'ADC Chanel5' in reg: 'ADC Chanel 5'
    fmc_adc_core_adc_ch5_i                   : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'ADC Chanel6' in reg: 'ADC Chanel 6'
    fmc_adc_core_adc_ch6_i                   : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'ADC Chanel7' in reg: 'ADC Chanel 7'
    fmc_adc_core_adc_ch7_i                   : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'ADC Chanel8' in reg: 'ADC Chanel 8'
    fmc_adc_core_adc_ch8_i                   : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Samples counter' in reg: 'Samples counter'
    fmc_adc_core_samples_cnt_i               : in     std_logic_vector(31 downto 0)
  );
end fmc_adc_18b_400ks_csr;

architecture syn of fmc_adc_18b_400ks_csr is

signal fmc_adc_core_ctl_fsm_cmd_int             : std_logic_vector(1 downto 0);
signal fmc_adc_core_ctl_adc_volt_rage_int       : std_logic      ;
signal fmc_adc_core_ctl_adc_os_int              : std_logic_vector(2 downto 0);
signal fmc_adc_core_ctl_adc_n_dbl_rate_int      : std_logic      ;
signal fmc_adc_core_ctl_adc_n_dbl_rate_sync0    : std_logic      ;
signal fmc_adc_core_ctl_adc_n_dbl_rate_sync1    : std_logic      ;
signal fmc_adc_core_sta_adc_fsm_int             : std_logic_vector(2 downto 0);
signal fmc_adc_core_sta_adc_fsm_lwb             : std_logic      ;
signal fmc_adc_core_sta_adc_fsm_lwb_delay       : std_logic      ;
signal fmc_adc_core_sta_adc_fsm_lwb_in_progress : std_logic      ;
signal fmc_adc_core_sta_adc_fsm_lwb_s0          : std_logic      ;
signal fmc_adc_core_sta_adc_fsm_lwb_s1          : std_logic      ;
signal fmc_adc_core_sta_adc_fsm_lwb_s2          : std_logic      ;
signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal bwsel_reg                                : std_logic_vector(3 downto 0);
signal rwaddr_reg                               : std_logic_vector(3 downto 0);
signal ack_in_progress                          : std_logic      ;
signal wr_int                                   : std_logic      ;
signal rd_int                                   : std_logic      ;
signal allones                                  : std_logic_vector(31 downto 0);
signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments. For (foreseen) compatibility with other bus standards.
  wrdata_reg <= wb_dat_i;
  bwsel_reg <= wb_sel_i;
  rd_int <= wb_cyc_i and (wb_stb_i and (not wb_we_i));
  wr_int <= wb_cyc_i and (wb_stb_i and wb_we_i);
  allones <= (others => '1');
  allzeros <= (others => '0');
-- 
-- Main register bank access process.
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= "0000000000";
      ack_in_progress <= '0';
      rddata_reg <= "00000000000000000000000000000000";
      fmc_adc_core_ctl_fsm_cmd_int <= "00";
      fmc_adc_core_ctl_adc_volt_rage_int <= '0';
      fmc_adc_core_ctl_adc_os_int <= "000";
      fmc_adc_core_ctl_adc_n_dbl_rate_int <= '0';
      fmc_adc_core_sta_adc_fsm_lwb <= '0';
      fmc_adc_core_sta_adc_fsm_lwb_delay <= '0';
      fmc_adc_core_sta_adc_fsm_lwb_in_progress <= '0';
    elsif rising_edge(clk_sys_i) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          ack_in_progress <= '0';
        else
          fmc_adc_core_sta_adc_fsm_lwb <= fmc_adc_core_sta_adc_fsm_lwb_delay;
          fmc_adc_core_sta_adc_fsm_lwb_delay <= '0';
          if ((ack_sreg(1) = '1') and (fmc_adc_core_sta_adc_fsm_lwb_in_progress = '1')) then
            rddata_reg(5 downto 3) <= fmc_adc_core_sta_adc_fsm_int;
            fmc_adc_core_sta_adc_fsm_lwb_in_progress <= '0';
          end if;
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(3 downto 0) is
          when "0000" => 
            if (wb_we_i = '1') then
              fmc_adc_core_ctl_fsm_cmd_int <= wrdata_reg(1 downto 0);
              fmc_adc_core_ctl_adc_volt_rage_int <= wrdata_reg(2);
              fmc_adc_core_ctl_adc_os_int <= wrdata_reg(5 downto 3);
              fmc_adc_core_ctl_adc_n_dbl_rate_int <= wrdata_reg(6);
            end if;
            rddata_reg(1 downto 0) <= fmc_adc_core_ctl_fsm_cmd_int;
            rddata_reg(2) <= fmc_adc_core_ctl_adc_volt_rage_int;
            rddata_reg(5 downto 3) <= fmc_adc_core_ctl_adc_os_int;
            rddata_reg(6) <= fmc_adc_core_ctl_adc_n_dbl_rate_int;
            rddata_reg(31 downto 7) <= fmc_adc_core_ctl_reserved_i;
            ack_sreg(3) <= '1';
            ack_in_progress <= '1';
          when "0001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(2 downto 0) <= fmc_adc_core_sta_fsm_i;
            if (wb_we_i = '0') then
              fmc_adc_core_sta_adc_fsm_lwb <= '1';
              fmc_adc_core_sta_adc_fsm_lwb_delay <= '1';
              fmc_adc_core_sta_adc_fsm_lwb_in_progress <= '1';
            end if;
            rddata_reg(31 downto 6) <= fmc_adc_core_sta_reserved_i;
            ack_sreg(5) <= '1';
            ack_in_progress <= '1';
          when "0010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= fmc_adc_core_adc_ch1_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= fmc_adc_core_adc_ch2_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= fmc_adc_core_adc_ch3_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= fmc_adc_core_adc_ch4_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= fmc_adc_core_adc_ch5_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= fmc_adc_core_adc_ch6_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= fmc_adc_core_adc_ch7_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= fmc_adc_core_adc_ch8_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= fmc_adc_core_samples_cnt_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Drive the data output bus
  wb_dat_o <= rddata_reg;
-- State machine commands (ignore on read)
  fmc_adc_core_ctl_fsm_cmd_o <= fmc_adc_core_ctl_fsm_cmd_int;
-- Range
  fmc_adc_core_ctl_adc_volt_rage_o <= fmc_adc_core_ctl_adc_volt_rage_int;
-- Oversampling Mode
  fmc_adc_core_ctl_adc_os_o <= fmc_adc_core_ctl_adc_os_int;
-- not Double Rate Input
-- synchronizer chain for field : not Double Rate Input (type RW/RO, clk_sys_i <-> adc_clk_i)
  process (adc_clk_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      fmc_adc_core_ctl_adc_n_dbl_rate_o <= '0';
      fmc_adc_core_ctl_adc_n_dbl_rate_sync0 <= '0';
      fmc_adc_core_ctl_adc_n_dbl_rate_sync1 <= '0';
    elsif rising_edge(adc_clk_i) then
      fmc_adc_core_ctl_adc_n_dbl_rate_sync0 <= fmc_adc_core_ctl_adc_n_dbl_rate_int;
      fmc_adc_core_ctl_adc_n_dbl_rate_sync1 <= fmc_adc_core_ctl_adc_n_dbl_rate_sync0;
      fmc_adc_core_ctl_adc_n_dbl_rate_o <= fmc_adc_core_ctl_adc_n_dbl_rate_sync1;
    end if;
  end process;
  
  
-- Reserved
-- State machine status
-- ADC State machine status
-- asynchronous std_logic_vector register : ADC State machine status (type RO/WO, adc_clk_i <-> clk_sys_i)
  process (adc_clk_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      fmc_adc_core_sta_adc_fsm_lwb_s0 <= '0';
      fmc_adc_core_sta_adc_fsm_lwb_s1 <= '0';
      fmc_adc_core_sta_adc_fsm_lwb_s2 <= '0';
      fmc_adc_core_sta_adc_fsm_int <= "000";
    elsif rising_edge(adc_clk_i) then
      fmc_adc_core_sta_adc_fsm_lwb_s0 <= fmc_adc_core_sta_adc_fsm_lwb;
      fmc_adc_core_sta_adc_fsm_lwb_s1 <= fmc_adc_core_sta_adc_fsm_lwb_s0;
      fmc_adc_core_sta_adc_fsm_lwb_s2 <= fmc_adc_core_sta_adc_fsm_lwb_s1;
      if ((fmc_adc_core_sta_adc_fsm_lwb_s1 = '1') and (fmc_adc_core_sta_adc_fsm_lwb_s2 = '0')) then
        fmc_adc_core_sta_adc_fsm_int <= fmc_adc_core_sta_adc_fsm_i;
      end if;
    end if;
  end process;
  
  
-- Reserved
-- ADC Chanel1
-- ADC Chanel2
-- ADC Chanel3
-- ADC Chanel4
-- ADC Chanel5
-- ADC Chanel6
-- ADC Chanel7
-- ADC Chanel8
-- Samples counter
  rwaddr_reg <= wb_adr_i;
  wb_stall_o <= (not ack_sreg(0)) and (wb_stb_i and wb_cyc_i);
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;
