---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for FMC ADC 18bits 400kS/s FV control registers
---------------------------------------------------------------------------------------
-- File           : fmc_adc_18b_FV_Ctrl_csr.vhd
-- Author         : auto-generated by wbgen2 from ./fmc_adc_18b_FV_Ctrl_csr.wb
-- Created        : Thu Jul 30 09:32:36 2015
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE ./fmc_adc_18b_FV_Ctrl_csr.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity fmc_adc_18b_FV_Ctrl_csr is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    wb_adr_i                                 : in     std_logic_vector(0 downto 0);
    wb_dat_i                                 : in     std_logic_vector(31 downto 0);
    wb_dat_o                                 : out    std_logic_vector(31 downto 0);
    wb_cyc_i                                 : in     std_logic;
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
    wb_stb_i                                 : in     std_logic;
    wb_we_i                                  : in     std_logic;
    wb_ack_o                                 : out    std_logic;
    wb_stall_o                               : out    std_logic;
-- Ports for BIT field: 'FV_relay_sta' in reg: 'Control and Status'
    fmc_fv_ctrl_ctrl_sta_relay_o             : out    std_logic;
    fmc_fv_ctrl_ctrl_sta_relay_i             : in     std_logic;
    fmc_fv_ctrl_ctrl_sta_relay_load_o        : out    std_logic;
-- Port for std_logic_vector field: 'FV_Led_sta' in reg: 'Control and Status'
    fmc_fv_ctrl_ctrl_sta_led_i               : in     std_logic_vector(2 downto 0);
-- Port for std_logic_vector field: 'Reading_mode' in reg: 'Control and Status'
    fmc_fv_ctrl_ctrl_sta_read_mode_o         : out    std_logic_vector(1 downto 0);
-- Port for BIT field: 'Spare Led' in reg: 'Control and Status'
    fmc_fv_ctrl_ctrl_sta_sp1_o               : out    std_logic;
-- Port for std_logic_vector field: 'Floating ground Voltage' in reg: 'Control and Status'
    fmc_fv_ctrl_ctrl_sta_fv_i                : in     std_logic_vector(9 downto 0);
-- Port for std_logic_vector field: 'Maximum Voltage' in reg: 'range of voltage voltages'
    fmc_fv_ctrl_lim_max_o                    : out    std_logic_vector(9 downto 0);
    fmc_fv_ctrl_lim_max_i                    : in     std_logic_vector(9 downto 0);
    fmc_fv_ctrl_lim_max_load_o               : out    std_logic;
-- Port for std_logic_vector field: 'Minimum voltage' in reg: 'range of voltage voltages'
    fmc_fv_ctrl_lim_min_o                    : out    std_logic_vector(9 downto 0);
    fmc_fv_ctrl_lim_min_i                    : in     std_logic_vector(9 downto 0);
    fmc_fv_ctrl_lim_min_load_o               : out    std_logic
  );
end fmc_adc_18b_FV_Ctrl_csr;

architecture syn of fmc_adc_18b_FV_Ctrl_csr is

signal fmc_fv_ctrl_ctrl_sta_read_mode_int       : std_logic_vector(1 downto 0);
signal fmc_fv_ctrl_ctrl_sta_sp1_int             : std_logic      ;
signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal bwsel_reg                                : std_logic_vector(3 downto 0);
signal rwaddr_reg                               : std_logic_vector(0 downto 0);
signal ack_in_progress                          : std_logic      ;
signal wr_int                                   : std_logic      ;
signal rd_int                                   : std_logic      ;
signal allones                                  : std_logic_vector(31 downto 0);
signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments. For (foreseen) compatibility with other bus standards.
  wrdata_reg <= wb_dat_i;
  bwsel_reg <= wb_sel_i;
  rd_int <= wb_cyc_i and (wb_stb_i and (not wb_we_i));
  wr_int <= wb_cyc_i and (wb_stb_i and wb_we_i);
  allones <= (others => '1');
  allzeros <= (others => '0');
-- 
-- Main register bank access process.
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= "0000000000";
      ack_in_progress <= '0';
      rddata_reg <= "00000000000000000000000000000000";
      fmc_fv_ctrl_ctrl_sta_relay_load_o <= '0';
      fmc_fv_ctrl_ctrl_sta_read_mode_int <= "00";
      fmc_fv_ctrl_ctrl_sta_sp1_int <= '0';
      fmc_fv_ctrl_lim_max_load_o <= '0';
      fmc_fv_ctrl_lim_min_load_o <= '0';
    elsif rising_edge(clk_sys_i) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          fmc_fv_ctrl_ctrl_sta_relay_load_o <= '0';
          fmc_fv_ctrl_lim_max_load_o <= '0';
          fmc_fv_ctrl_lim_min_load_o <= '0';
          ack_in_progress <= '0';
        else
          fmc_fv_ctrl_ctrl_sta_relay_load_o <= '0';
          fmc_fv_ctrl_lim_max_load_o <= '0';
          fmc_fv_ctrl_lim_min_load_o <= '0';
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(0) is
          when '0' => 
            if (wb_we_i = '1') then
              fmc_fv_ctrl_ctrl_sta_relay_load_o <= '1';
              fmc_fv_ctrl_ctrl_sta_read_mode_int <= wrdata_reg(5 downto 4);
              fmc_fv_ctrl_ctrl_sta_sp1_int <= wrdata_reg(6);
            end if;
            rddata_reg(0) <= fmc_fv_ctrl_ctrl_sta_relay_i;
            rddata_reg(3 downto 1) <= fmc_fv_ctrl_ctrl_sta_led_i;
            rddata_reg(5 downto 4) <= fmc_fv_ctrl_ctrl_sta_read_mode_int;
            rddata_reg(6) <= fmc_fv_ctrl_ctrl_sta_sp1_int;
            rddata_reg(25 downto 16) <= fmc_fv_ctrl_ctrl_sta_fv_i;
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when '1' => 
            if (wb_we_i = '1') then
              fmc_fv_ctrl_lim_max_load_o <= '1';
              fmc_fv_ctrl_lim_min_load_o <= '1';
            end if;
            rddata_reg(9 downto 0) <= fmc_fv_ctrl_lim_max_i;
            rddata_reg(25 downto 16) <= fmc_fv_ctrl_lim_min_i;
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Drive the data output bus
  wb_dat_o <= rddata_reg;
-- FV_relay_sta
  fmc_fv_ctrl_ctrl_sta_relay_o <= wrdata_reg(0);
-- FV_Led_sta
-- Reading_mode
  fmc_fv_ctrl_ctrl_sta_read_mode_o <= fmc_fv_ctrl_ctrl_sta_read_mode_int;
-- Spare Led
  fmc_fv_ctrl_ctrl_sta_sp1_o <= fmc_fv_ctrl_ctrl_sta_sp1_int;
-- Floating ground Voltage
-- Maximum Voltage
  fmc_fv_ctrl_lim_max_o <= wrdata_reg(9 downto 0);
-- Minimum voltage
  fmc_fv_ctrl_lim_min_o <= wrdata_reg(25 downto 16);
  rwaddr_reg <= wb_adr_i;
  wb_stall_o <= (not ack_sreg(0)) and (wb_stb_i and wb_cyc_i);
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;
